<script setup>
import { onMounted, reactive, ref } from "vue";
import TextInput from "../components/ui/TextInput.vue";
import Button from "../components/ui/Button.vue";
import Api from "../api";
import { useRouter } from "vue-router";

const router = useRouter();
const btnLoading = ref(false);
const deleteBtnLoading = ref(null);
const logoutLoading = ref(false);
const taskForm = ref({ title: "", description: "" });
const errors = ref({});
const tasks = ref([]);

onMounted(async () => {
  try {
    let res = await Api.getInstance().taskService().getList();
    tasks.value = res.data.data;
  } catch (error) {}
});

const submitForm = async () => {
  btnLoading.value = true;
  try {
    let res = taskForm.value.id
      ? await Api.getInstance()
          .taskService()
          .update(taskForm.value.id, taskForm.value)
      : await Api.getInstance().taskService().create(taskForm.value);

    tasks.value = taskForm.value.id
      ? tasks.value.map((el) => {
          return el.id == taskForm.value.id ? res.data.data : el;
        })
      : [...tasks.value, res.data.data];
    errors.value = {};
    cancel();
  } catch (error) {
    if (error.response.status == 422) {
      errors.value = error.response.data.errors;
    }
  }

  btnLoading.value = false;
};
const deleteTask = async (task) => {
  deleteBtnLoading.value = task.id;
  Api.getInstance()
    .taskService()
    .delete(task.id)
    .then((res) => {
      tasks.value = tasks.value.filter((el) => el.id != task.id);
      deleteBtnLoading.value = null;
    })
    .catch((err) => {
      deleteBtnLoading.value = null;
    });
};
const editTask = async (task) => {
  taskForm.value = { ...task };
};
const cancel = () => {
  taskForm.value = { title: "", description: "" };
};

const logout = async () => {
  logoutLoading.value = true;
  try {
    await Api.getInstance().authService().logout();
    localStorage.removeItem("token");
    router.replace({ name: "Login" });
  } catch (error) {}
  logoutLoading.value = false;
};
</script>

<template>
  <div class="pa-2">
    <div class="flex nav pa-1 mb">
      <h3 class="bolder">Welcome to ToDo App</h3>
      <Button small @onClick="logout" :loading="logoutLoading"> Logout </Button>
    </div>
    <div class="flex">
      <div class="card pa form mr-1 pa-1">
        <form @submit.prevent="submitForm" class="w-full flex-col">
          <h2 class="bold mb-1">Tasks form</h2>
          <TextInput
            label="Title"
            placeholder="Enter task title"
            v-model="taskForm.title"
            :error="errors.title"
          />
          <TextInput
            textarea
            label="Description"
            placeholder="Enter task"
            v-model="taskForm.description"
            :error="errors.description"
          />
          <div class="mt-1 flex end">
            <Button outline @onClick="cancel" v-if="taskForm.id">
              cancel
            </Button>
            <Button class="ml" type="submit" :loading="btnLoading">
              {{ taskForm.id ? "update task" : "create new task" }}
            </Button>
          </div>
        </form>
      </div>
      <div class="card pa list overflew-scroll">
        <h2 class="bold pa">List of tasks</h2>
        <div class="task mb pa flex-col" v-for="task in tasks" :key="task.id">
          <div class="medium">{{ task.title }}</div>
          <div class="fs8 mt mb">{{ task.description }}</div>
          <div class="ml-auto flex-end">
            <Button @onClick="editTask(task)" small success> edit </Button>
            <Button
              @onClick="deleteTask(task)"
              class="ml"
              small
              danger
              :loading="deleteBtnLoading == task.id"
            >
              delete
            </Button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.nav {
  align-items: center;
  justify-content: space-between;
  background: rgba(5, 146, 185, 0.242);
  color: rgb(5, 146, 185);
  border-radius: 5px;
}
.form {
  flex: 1;
  display: flex;
  align-self: baseline;

  .end {
    justify-content: flex-end;
  }
}
.list {
  flex: 2;
  max-height: 80vh;

  .task {
    border-bottom: 2px solid #ccc;

    .fs9 {
      color: #444;
    }
  }
}
@media (min-width: 1024px) {
  .about {
    min-height: 100vh;
    display: flex;
    align-items: center;
  }
}
</style>
